#include<iostream>
using namespace std;
//class for person as problem discription
class Person {
	private:
		const int id;
		unsigned int friendCount;
		int* friendList;
	public:
		Person(int id);
		~Person();
		int getId() const;
		bool addFriend(int anId);
		bool unfriend(int anId);
};
//a function used to check whether A and B are real friends
//it will return true if they are friends, false otherwise
bool checkFriend(Person* A, Person* B);
int main() {
	int peopleCount=0;
	//because of the max number of given people, declare peopleList with length 1000
	Person* peopleList[1000];
	char event;
	//input start
	while(cin>>event) {
		//do things according to the given event
		if(event=='N') {
			//a new person come
			int id;
			cin>>id;
			int index=peopleCount;
			//find the index to insert
			//this can maintain the list sorted by id from small to large
			for(int i=0; i<peopleCount; i++) {
				if(peopleList[i]->getId()>id) {
					index=i;
					break;
				}
			}
			for(int i=peopleCount-1; i>=index; i--) {
				peopleList[i+1]=peopleList[i];
			}
			peopleList[index]=new Person(id);
			peopleCount++;
		} else if(event=='A') {
			//add a request
			int requestFrom, requestTo;
			cin>>requestFrom>>requestTo;
			//find the person who send the request and call the corresponding function
			for(int i=0; i<peopleCount; i++) {
				if(peopleList[i]->getId()==requestFrom) {
					peopleList[i]->addFriend(requestTo);
					break;
				}
			}
		} else if(event=='R') {
			//remove the request
			int requestFrom, requestTo;
			cin>>requestFrom>>requestTo;
			//find the person who remove the request and call the corresponding function
			for(int i=0; i<peopleCount; i++) {
				if(peopleList[i]->getId()==requestFrom) {
					peopleList[i]->unfriend(requestTo);
					break;
				}
			}
			
		} else
			break;
	}
	//input end
	
	//declare the friendCountList and initialize it
	int* friendCountList=new int[peopleCount];
	for(int i=0; i<peopleCount; i++) {
		friendCountList[i]=0;
	}
	
	//check if any two people are friends
	//if they are, add one to the friendCount of the two people
	for(int i=0; i<peopleCount-1; i++) {
		for(int j=i+1; j<peopleCount; j++) {
			if(checkFriend(peopleList[i], peopleList[j])) {
				friendCountList[i]++;
				friendCountList[j]++;
			}
		}
	}
	//find the largest friend numer
	int most=0;
	for(int i=0; i<peopleCount; i++) {
		if(friendCountList[i]>most)
			most=friendCountList[i];
	}
	//output all the people who's friend number is equal to the largest friend number
	for(int i=0; i<peopleCount; i++) {
		if(friendCountList[i]==most)
			cout<<peopleList[i]->getId()<<" ";
	}
	cout<<most<<endl;
	return 0;
}
bool Person::addFriend(int anId) {
	bool alreadyAdd=false;
	//check if the person is already added or sending the request to himself
	for(int i=0; i<friendCount; i++) {
		if(friendList[i]==anId) {
			alreadyAdd=true;
			break;
		}
	}
	//if so, return false
	if(alreadyAdd||anId==id) {
		return false;
	} else {
		//else, add the request
		int* newFriendList=new int[friendCount+1];
		for(int i=0; i<friendCount; i++) {
			newFriendList[i]=friendList[i];
		}
		delete[] friendList;
		newFriendList[friendCount]=anId;
		friendCount++;
		friendList=newFriendList;
		return true;
	}
}
int Person::getId() const {
	return id;
}
Person::Person(int id) :id(id) {
	friendCount=0;
	friendList=NULL;
}
bool Person::unfriend(int anId) {
	int index=-1;
	//check whether the request exist 
	for(int i=0; i<friendCount; i++) {
		if(friendList[i]==anId) {
			index=i;
			break;
		}
	}
	//if no, return false
	if(index==-1) {
		return false;
	} else {
		//else, remove it
		int* newFriendList=new int[friendCount-1];
		for(int i=0; i<index; i++) {
			newFriendList[i]=friendList[i];
		}
		for(int i=index+1; i<friendCount; i++) {
			newFriendList[i-1]=friendList[i];
		}
		friendCount--;
		delete[] friendList;
		friendList=newFriendList;
	}
}
Person::~Person() {
	this->friendCount=0;
	delete[] this->friendList;
}

//if the two people are friends, the function of unfriend each other will both return true
bool checkFriend(Person* A, Person* B) {
	return (A->unfriend(B->getId())&&B->unfriend(A->getId()));
}
