#include<iostream>
using namespace std;
//i will only comment on the part which problem 1 doesn't have
class Person {
	private:
		const int id;
		unsigned int friendCount;
		Person** friendList;
	public:
		Person(int id);
		~Person();
		int getId() const;
		void addFriend(Person* aPersonPtr);
		bool unfriend(int anId);
};
bool checkFriend(Person* A, Person* B);
int main() {
	int peopleCount=0;
	Person* peopleList[1000];
	char event;
	while(cin>>event) {
		if(event=='N') {
			int id;
			cin>>id;
			int index=peopleCount;
			for(int i=0; i<peopleCount; i++) {
				if(peopleList[i]->getId()>id) {
					index=i;
					break;
				}
			}
			for(int i=peopleCount-1; i>=index; i--) {
				peopleList[i+1]=peopleList[i];
			}
			peopleList[index]=new Person(id);
			peopleCount++;
		} else if(event=='A') {
			int requestFrom, requestTo;
			cin>>requestFrom>>requestTo;
			for(int i=0; i<peopleCount; i++) {
				if(peopleList[i]->getId()==requestFrom) {
					for(int j=0; j<peopleCount; j++) {
						if(peopleList[j]->getId()==requestTo) {
							peopleList[i]->addFriend(peopleList[j]);
							break;
						}
					}
					break;
				}
			}
		} else if(event=='R') {
			int requestFrom, requestTo;
			cin>>requestFrom>>requestTo;
			for(int i=0; i<peopleCount; i++) {
				if(peopleList[i]->getId()==requestFrom) {
					peopleList[i]->unfriend(requestTo);
					break;
				}
			}
			
		} else if(event=='L') {
			//someone leave
			int id;
			cin>>id;
			//every people unfriend him
			for(int i=0; i<peopleCount; i++) {
				peopleList[i]->unfriend(id);
			}
			//after delete it, the person who's id is larger than him is moved forward
			bool alreadyDelete=false;
			for(int i=0; i<peopleCount; i++) {
				if(alreadyDelete) {
					if(i!=peopleCount-1)
						peopleList[i]=peopleList[i+1];
					else
						peopleList[i]=NULL;
				}
				else if(peopleList[i]->getId()==id) {
					delete peopleList[i];
					alreadyDelete=true;
					if(i!=peopleCount-1)
						peopleList[i]=peopleList[i+1];
					else
						peopleList[i]=NULL;
				}
			}
			peopleCount--;
		} else
			break;
	}
	int* friendCountList=new int[peopleCount];
	for(int i=0; i<peopleCount; i++) {
		friendCountList[i]=0;
	}
	for(int i=0; i<peopleCount-1; i++) {
		for(int j=i+1; j<peopleCount; j++) {
			if(checkFriend(peopleList[i], peopleList[j])) {
				friendCountList[i]++;
				friendCountList[j]++;
			}
		}
	}
	int most=0;
	for(int i=0; i<peopleCount; i++) {
		if(friendCountList[i]>most)
			most=friendCountList[i];
	}
	for(int i=0; i<peopleCount; i++) {
		if(friendCountList[i]==most)
			cout<<peopleList[i]->getId()<<" ";
	}
	cout<<most<<endl;
	return 0;
}
void Person::addFriend(Person* aPersonPtr) {
	//add friend is different
	//the main different is that we should get id from the personPointer
	//instead of get the id record in the list
	bool alreadyAdd=false;
	for(int i=0; i<friendCount; i++) {
		if(friendList[i]->getId()==aPersonPtr->getId()) {
			alreadyAdd=true;
			break;
		}
	}
	if(!alreadyAdd&&aPersonPtr->getId()!=id) {
		Person** newFriendList=new Person*[friendCount+1];
		for(int i=0; i<friendCount; i++) {
			newFriendList[i]=friendList[i];
		}
		delete[] friendList;
		newFriendList[friendCount]=aPersonPtr;
		friendCount++;
		friendList=newFriendList;
	}
}
int Person::getId() const {
	return id;
}
Person::Person(int id) :id(id) {
	friendCount=0;
	friendList=NULL;
}
bool Person::unfriend(int anId) {
	int index=-1;
	for(int i=0; i<friendCount; i++) {
		if(friendList[i]->getId()==anId) {
			index=i;
			break;
		}
	}
	if(index==-1) {
		return false;
	} else {
		Person** newFriendList=new Person*[friendCount-1];
		for(int i=0; i<index; i++) {
			newFriendList[i]=friendList[i];
		}
		for(int i=index+1; i<friendCount; i++) {
			newFriendList[i-1]=friendList[i];
		}
		friendCount--;
		delete[] friendList;
		friendList=newFriendList;
		return true;
	}
}
Person::~Person() {
	this->friendCount=0;
	delete[] this->friendList;
}

bool checkFriend(Person* A, Person* B) {
	return (A->unfriend(B->getId())&&B->unfriend(A->getId()));
}
